#!/bin/bash

set -e

if [ $UID -ne 0 ]; then
    echo "请用root用户运行当前脚本 (su root)" && exit 1
fi

APP_COMPARTMENT="nsq-server"
APP_MODULE="nsq-server"

root_dir=/opt/$APP_COMPARTMENT/$APP_MODULE

if [ ! -d "$root_dir" ]; then
        mkdir -p $root_dir
fi

# Don't delete `/`
if [[ $root_dir == "/" ]]; then
    echo "root_dir is /, exit"
    exit 1
fi

systemctl stop $APP_MODULE
systemctl disable $APP_MODULE

rm -rf $root_dir
rm -f /etc/systemd/system/$APP_MODULE.service

if [ -d "/opt/$APP_COMPARTMENT" ] && [ -z "$(ls -A /opt/$APP_COMPARTMENT)" ]; then
    rmdir /opt/$APP_COMPARTMENT
else
    echo "目录 /opt/$APP_COMPARTMENT 非空，不删除"
fi

echo "卸载成功！"

systemctl daemon-reload
